SystemOrganization addCategory: #'MorphoPhysics-Test'!
SystemOrganization addCategory: #MorphoPhysics!
SystemOrganization addCategory: #'MorphoPhysics-Application'!
SystemOrganization addCategory: #'MorphoPhysics-Seaside'!
SystemOrganization addCategory: #'MorphoPhysics-Tools'!

TestCase subclass: #BallMorphTest
	instanceVariableNames: 'ballMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics-Test'!

!BallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/5/2009 14:45'!
setUp

	super setUp.
	ballMorph := BallMorph new! !

!BallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/5/2009 16:18'!
testAcceleratedBy
	ballMorph velocity: 5 @ 0.
	ballMorph acceleratedBy: 1 @ -2.
	self assert: ballMorph velocity = (6 @ -2)! !

!BallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/5/2009 14:47'!
testAccessingVelocity
	ballMorph velocity: 5 @ 0.
	self assert: ballMorph velocity = (5 @ 0)! !

!BallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/5/2009 16:39'!
testAngularlyAcceleratedBy10RotationCenterPoint0at20
	"angularlyAcceleratedBy: aNumber rotationCenterPoint: aPoint"
	| v |
	self assert: ballMorph center = (20 @ 20).
	ballMorph angularlyAcceleratedBy: 10 rotationCenterPoint: 0 @ 20.
	v := ballMorph velocity.
	self
		assert: (v x between: -0.0001 and: 0.0001).
	self
		assert: (v y between: 9.99999 and: 10.0001)! !

!BallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/5/2009 16:40'!
testAngularlyAcceleratedBy10RotationCenterPoint40at20
	"angularlyAcceleratedBy: aNumber rotationCenterPoint: aPoint"
	| v |
	self assert: ballMorph center = (20 @ 20).
	ballMorph angularlyAcceleratedBy: 10 rotationCenterPoint: 40 @ 20.
	v := ballMorph velocity.
	self
		assert: (v x between: -0.0001 and: 0.0001).
	self
		assert: (v y between: -10.0001 and: -9.99999)! !

!BallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/5/2009 16:41'!
testAngularlyAcceleratedBy20RotationCenterPoint0at20
	"angularlyAcceleratedBy: aNumber rotationCenterPoint: aPoint"
	| v |
	self assert: ballMorph center = (20 @ 20).
	ballMorph angularlyAcceleratedBy: 20 rotationCenterPoint: 0 @ 20.
	v := ballMorph velocity.
	self
		assert: (v x between: -0.0001 and: 0.0001).
	self
		assert: (v y between: 19.99999 and: 20.0001)! !

!BallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/5/2009 16:42'!
testAngularlyAcceleratedBy20RotationCenterPoint40at20
	"angularlyAcceleratedBy: aNumber rotationCenterPoint: aPoint"
	| v |
	self assert: ballMorph center = (20 @ 20).
	ballMorph angularlyAcceleratedBy: 20 rotationCenterPoint: 40 @ 20.
	v := ballMorph velocity.
	self
		assert: (v x between: -0.0001 and: 0.0001).
	self
		assert: (v y between: -20.0001 and: -19.99999)! !

!BallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/5/2009 14:53'!
testApplyFriction
	| v |
	ballMorph velocity: 5 @ 0.
	ballMorph applyFriction.
	v := ballMorph velocity.
	self assert: (v x between: 0 and: 5).
	self assert: (v y between: -0.0001 and: 0.0001)  ! !

!BallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/5/2009 16:21'!
testForcedBy
	self assert: ballMorph velocity = (0 @ 0).
	ballMorph mass: 100.
	ballMorph forcedBy: 1000 @ 0.
	self assert: ballMorph velocity = (10 @ 0).
	ballMorph mass: 10.
	ballMorph forcedBy: 0 @ 1000.
	self assert: ballMorph velocity = (10 @ 100).
	! !

!BallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/5/2009 14:49'!
testMoveByVelocity
	
	ballMorph bounds: (0@0 corner: 40@40).
	self assert: (ballMorph bounds = (0@0 corner: 40@40)).
	ballMorph velocity: 5 @ 0.
	ballMorph moveByVelocity.
		self assert: (ballMorph bounds = (5@0 corner: 45@40)).
! !

!BallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/3/2009 17:50'!
testStoreOn

	| stream |
	stream := WriteStream on: String new.
	ballMorph storeOn: stream.
	self assert: stream contents =  'BallMorph newPosition: 0@0'! !

BallMorphTest subclass: #ConceptBallMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics-Test'!

!ConceptBallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/5/2009 17:38'!
setUp
	super setUp.
	ballMorph := ConceptBallMorph new! !

!ConceptBallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/5/2009 17:42'!
testContents
	ballMorph contents: 'jimmy whales'.
	self assert: ballMorph contents = 'jimmy whales'.
	self assert: (ballMorph contentsIs: 'jimmy whales')! !

!ConceptBallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/5/2009 17:45'!
testLabelMorph
	self assert: ballMorph labelMorph class = StringMorph.
	self assert: ballMorph labelMorph contents =  'name me'! !

!ConceptBallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/5/2009 17:51'!
testOpenDeleteLabel
	ballMorph contents: 'jimmy whales'.
	ballMorph openLabel.
	self assert: ballMorph labelMorph class = StringMorph.
	self assert: ballMorph labelMorph contents = 'jimmy whales'.
	ballMorph deleteLabel.
	self assert: ballMorph labelMorphIsNil! !

!ConceptBallMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/3/2009 18:26'!
testStoreOn

	| stream |
	ballMorph position: 1@2.
	ballMorph contents: 'hello squeak'.
	stream := WriteStream on: String new.
	ballMorph storeOn: stream.

	self assert: stream contents =   'ConceptBallMorph newConceptName:''hello squeak'' position: 1@2'! !

TestCase subclass: #ForceMorphTest
	instanceVariableNames: 'forceMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics-Test'!

ForceMorphTest subclass: #ElectricForceMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics-Test'!

!ElectricForceMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 08:30'!
classToTest

	^ElectricForceMorph! !

!ElectricForceMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 08:35'!
testForceFromDisplacementVector

 	| force |
	force := forceMorph forceFromDisplacementVector: 300@400.
	self assert: force truncated = (2@3).
	
	force := forceMorph forceFromDisplacementVector: 300@0.
	self assert: force truncated = (11@0).

	force := forceMorph forceFromDisplacementVector: 150@0.
	self assert: force truncated = (44@0).

	force := forceMorph forceFromDisplacementVector: 75@0.
	self assert: force truncated = (177@0).
! !

!ElectricForceMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 08:40'!
testLineWidthForForce

	forceMorph force: 10@0.
	self assert: forceMorph lineWidthForForce truncated =  10.
	
	forceMorph force: 3@-4.
	self assert: forceMorph lineWidthForForce truncated =  5.! !

!ForceMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/28/2009 19:47'!
classToTest

	^ForceMorph! !

!ForceMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/28/2009 19:47'!
setUp

	super setUp.
	forceMorph := self classToTest newConnecting: BallMorph new and: BallMorph new! !

!ForceMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2009 14:26'!
testApplyForceBothEnds
	| v1 v2 |
	v1 := forceMorph ball1 velocity.
	v2 := forceMorph ball2 velocity.
	self assert: 0 @ 0 = v1.
	self assert: 0 @ 0 = v2.
	forceMorph applyForceBothEnds: 2000@1000.
	forceMorph ball1 moveByVelocity.
	forceMorph ball2 moveByVelocity.
	v1 := forceMorph ball1 velocity.
	v2 := forceMorph ball2 velocity.
	self deny: 0 @ 0 = v1.
	self deny: 0 @ 0 = v2.
	self assert: 0 @ 0 = (v1 + v2)! !

!ForceMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2009 14:44'!
testAttachToCenterOfTwoBalls

	| testingBlock |
	testingBlock := [ forceMorph vertices = (Array with: 30 @ 10 with: 0 @ 0) ].
	self deny: testingBlock.
	forceMorph ball1 center: 30 @ 10.
	forceMorph ball2 center: 0 @ 0.
	forceMorph attachToCenterOfTwoBalls.
	self assert: testingBlock! !

!ForceMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/28/2009 19:40'!
testBallDisplacementVector

	forceMorph ball1 center: 1@3.
	forceMorph ball2 center: 10@10.
	self assert: forceMorph ballDisplacementVector = (-9@-7)! !

!ForceMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/9/2009 21:54'!
testConnectingAnd

	| foreignBall |
	foreignBall := BallMorph new.
	self assert: (forceMorph connecting:  forceMorph ball1 and: forceMorph ball2).
	self deny: (forceMorph connecting:  forceMorph ball1 and: foreignBall).
	self deny: (forceMorph connecting:  forceMorph ball2 and: foreignBall).
	self assert: (forceMorph connecting:  forceMorph ball2 and: forceMorph ball1).! !

!ForceMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/28/2009 19:42'!
testCurrentLength

	forceMorph ball1 center: 1@3.
	forceMorph ball2 center: 10@10.
	self assert: (forceMorph currentLength between: 11.3 and: 11.5)
	
! !

ForceMorphTest subclass: #RubberBandMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics-Test'!

!RubberBandMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/28/2009 20:16'!
classToTest

	^RubberBandMorph! !

!RubberBandMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/28/2009 20:52'!
testForceFromDisplacementVector

 	| force |
	force := forceMorph forceFromDisplacementVector: 300@400.
	self assert: force truncated = (-180@-240)! !

!RubberBandMorphTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/28/2009 20:56'!
testLineWidthForLength

	self assert: (forceMorph lineWidthForLength: 10) = 60.
	self assert: (forceMorph lineWidthForLength: 100) = 6.
	self assert: (forceMorph lineWidthForLength: 600) = 1.
! !

TestCase subclass: #IdeaMapTest
	instanceVariableNames: 'ideaMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics-Test'!

!IdeaMapTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 09:00'!
setUp

	super setUp.
	ideaMap := IdeaMap new! !

!IdeaMapTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 16:25'!
tearDown

	super tearDown.
	ideaMap deleteMorphs! !

!IdeaMapTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 09:06'!
testAcceleratedBy

	"all balls get equally accelerated by certain amount of velocity."
	| ball1 ball2 |
	ball1 := BallMorph new.
	ball1 velocity: -10@0.
	ideaMap balls add: ball1.
	
	ball2 := BallMorph new.
	ball2 velocity: 0@10.
	ideaMap balls add: ball2.
	
	ideaMap acceleratedBy: 5@5.
	
	self assert: ball1 velocity = (-5@5).
	self assert: ball2 velocity = (5@15).! !

!IdeaMapTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 19:46'!
testAddConceptBalls

	ideaMap addConceptBalls: 'a,b,c'.
	self assert: ideaMap balls size = 4! !

!IdeaMapTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 19:48'!
testAddConceptBallsCenterNamed

	ideaMap addConceptBalls: 'a,b,c' centerNamed: 'test'.
	self assert: ideaMap balls size = 4.
	(ideaMap balls collect: [:each | each balloonText]) includesAllOf: #('a' 'b' 'c' 'test')! !

!IdeaMapTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 16:49'!
testAngularlyAcceleratedBy

	| ball1 ball2 ball3 ball4 |
	ball1 := BallMorph new.
	ball1 center: -100@-100.
	ideaMap balls add: ball1.

	ball2 := BallMorph new.
	ball2 center: 100@-100.
	ideaMap balls add: ball2.
		
	ball3 := BallMorph new.	
	ball3 center: 100@100.
	ideaMap balls add: ball3.

	ball4 := BallMorph new.	
	ball4 center: -100@100.
	ideaMap balls add: ball4.
	
	self assert: ball1 velocity isZero.
	self assert: ball2 velocity isZero.
	self assert: ball3 velocity isZero.
	self assert: ball4 velocity isZero.
	
	ideaMap angularlyAcceleratedBy: 0.1.
	
	self assert: ball1 velocity x > 0.
	self assert: ball1 velocity y < 0.
	
	self assert: ball2 velocity x > 0.
	self assert: ball2 velocity y > 0.

	self assert: ball3 velocity x < 0.
	self assert: ball3 velocity y > 0.

	self assert: ball4 velocity x < 0.
	self assert: ball4 velocity y < 0.

	self assert: (ball1 velocity + ball2 velocity + ball3 velocity + ball4 velocity) r < 0.0000001! !

!IdeaMapTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 16:34'!
testCanConnectSelectedConceptsStar

	ideaMap addConceptBalls: 'c1, c2, c3' centerNamed: 'my center'.
	self deny: ideaMap canConnectSelectedConceptsStar.

	ideaMap conceptsSelectedAt: 2 put: true.
	self assert: ideaMap canConnectSelectedConceptsStar.	 
	 ! !

!IdeaMapTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 18:26'!
testCenterOfMass

	| ball1 ball2 |	
	self should: [ ideaMap centerOfMass ] raise: Error.
	
	ball1 := BallMorph new.
	ball1 mass: 100.
	ball1 center: -100@-200.
	ideaMap balls add: ball1.
	self assert: ideaMap centerOfMass = (-100@-200).

	ball2 := BallMorph new.
	ball2 mass: 200.
	ball2 center: 200@-200.
	ideaMap balls add: ball2.
	self assert: ideaMap centerOfMass = (100@-200)! !

!IdeaMapTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 18:45'!
testConceptsSelection

	| ball1 ball2 ball3 |
	ball1 := BallMorph new.
	ball2 := BallMorph new.
	ball3 := BallMorph new.
	ideaMap balls add: ball1.
	ideaMap balls add: ball2.
	ideaMap balls add: ball3.
	
	self deny: (ideaMap conceptsSelectedAt: 1).
	self deny: (ideaMap conceptsSelectedAt: 2).
	self deny: (ideaMap conceptsSelectedAt: 3).
	
	ideaMap conceptsSelectedAt: 1 put: true.
	self assert: (ideaMap conceptsSelectedAt: 1).
	self deny: (ideaMap conceptsSelectedAt: 2).
	self deny: (ideaMap conceptsSelectedAt: 3).

	ideaMap conceptsSelectedAt: 2 put: true.
	self assert: (ideaMap conceptsSelectedAt: 1).
	self assert: (ideaMap conceptsSelectedAt: 2).
	self deny: (ideaMap conceptsSelectedAt: 3).

	ideaMap conceptsSelectedAt: 3 put: true.
	self assert: (ideaMap conceptsSelectedAt: 1).
	self assert: (ideaMap conceptsSelectedAt: 2).
	self assert: (ideaMap conceptsSelectedAt: 3).

	ideaMap conceptsSelectedAt: 2 put: false.
	self assert: (ideaMap conceptsSelectedAt: 1).
	self deny: (ideaMap conceptsSelectedAt: 2).
	self assert: (ideaMap conceptsSelectedAt: 3).

	ideaMap conceptsSelectedAt: 3 put: false.
	self assert: (ideaMap conceptsSelectedAt: 1).
	self deny: (ideaMap conceptsSelectedAt: 2).
	self deny: (ideaMap conceptsSelectedAt: 3).

	ideaMap conceptsSelectedAt: 1 put: false.
	self deny: (ideaMap conceptsSelectedAt: 1).
	self deny: (ideaMap conceptsSelectedAt: 2).
	self deny: (ideaMap conceptsSelectedAt: 3).
! !

!IdeaMapTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 19:55'!
testConnectExistingConceptsCenterNamed

	| ball1 ball2 ball3 |
	ball1 := BallMorph new.
	ball2 := BallMorph new.
	ball3 := BallMorph new.	
	ideaMap balls add: ball1.
	ideaMap balls add: ball2.
	ideaMap balls add: ball3.
	self assert: ideaMap rubberBandMorphs size = 0.

	ideaMap connectExistingConcepts: #() centerNamed: 'new center'.
	self assert: ideaMap rubberBandMorphs size = 0.
	
	ideaMap connectExistingConcepts: (Array with: ball1) centerNamed: 'new center1'.
	self assert: ideaMap rubberBandMorphs size = 1.

	ideaMap connectExistingConcepts: (Array with: ball2 with: ball3) centerNamed: 'new center23'.
	self assert: ideaMap rubberBandMorphs size = 3.
! !

!IdeaMapTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 20:09'!
testDeleteRubberBandsBetweenSelectedConcepts

	| ball1 ball2 ball3 |
	ball1 := BallMorph new.
	ball2 := BallMorph new.
	ball3 := BallMorph new.
	
	ideaMap balls add: ball1.
	ideaMap balls add: ball2.
	ideaMap balls add: ball3.
	
	ideaMap connectExistingConcepts: (Array with: ball1 with: ball2 with: ball3) centerNamed: 'all'.
	self assert: ideaMap rubberBandMorphs size = 3.
	
	ideaMap conceptsSelectedCollection: (Array with: (ideaMap getBallNamed: 'all') with: ball3 with: ball1).
	
	ideaMap deleteRubberBandsBetweenSelectedConcepts.
	self assert: ideaMap rubberBandMorphs size = 1.! !

!IdeaMapTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 18:32'!
testForcedBy

	| ball1 ball2 |
	ball1 := BallMorph new.
	ball1 mass: 100.
	ideaMap balls add: ball1.
	
	ball2 := BallMorph new.
	ball2 mass: 500.
	ideaMap balls add: ball2.
	
	self assert: ball1 velocity isZero.
	self assert: ball2 velocity isZero.
	
	ideaMap forcedBy: 1000@2000.
	
	self assert: ball1 velocity = (10@20).
	self assert: ball2 velocity = (2@4).! !

!IdeaMapTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 19:42'!
testGetOrCreateConceptBallNamed

	self assert: ideaMap balls isEmpty.
	
	ideaMap getOrCreateConceptBallNamed: 'a'.
	self assert: ideaMap balls size = 1.
	
	ideaMap getOrCreateConceptBallNamed: 'a'.
	self assert: ideaMap balls size = 1.
	self assert: (ideaMap getOrCreateConceptBallNamed: 'a') == (ideaMap getOrCreateConceptBallNamed: 'a')! !

!IdeaMapTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/29/2009 18:39'!
testMoveCenterOfMassToDisplayCenter

	ideaMap balls add: (BallMorph newPosition: 0@0).
	ideaMap balls add: (BallMorph newPosition: 500@0).
	ideaMap balls add: (BallMorph newPosition: 200@-30).
	self deny: (Display center - ideaMap centerOfMass) r < 1.
	
	ideaMap moveCenterOfMassToDisplayCenter.
	self assert: (Display center - ideaMap centerOfMass) r < 1
! !

EllipseMorph subclass: #BallMorph
	instanceVariableNames: 'velocity mass charge unselected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics'!

!BallMorph classSide methodsFor: 'eToys-scripting' stamp: 'hjo 4/28/2009 10:48'!
additionsToViewerCategories
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories."

	^
	#(
		(rigitBody 
			(
				(slot mass 'How heavy am I?' Number readWrite Player getMass Player setMass: )
				(slot velocityX 'moving per time' Number readWrite Player getVelocityX Player setVelocityX: )
				(slot velocityY 'moving per time' Number readWrite Player getVelocityY Player setVelocityY: )
				(command accelerateXBy: 'Give me a little push to x' Number)
				(command accelerateYBy: 'Give me a little push to y' Number)
			)
		)
	)


! !

!BallMorph classSide methodsFor: 'instance creation' stamp: 'hjo 8/29/2009 18:36'!
newPosition: aPoint 

	^self new position: aPoint! !

!BallMorph methodsFor: 'physics' stamp: 'hjo 4/28/2009 00:09'!
acceleratedBy: aPoint 

	self velocity: self velocity + aPoint! !

!BallMorph methodsFor: 'physics' stamp: 'hjo 7/11/2009 10:55'!
angularlyAcceleratedBy: aNumber rotationCenterPoint: aPoint 

		| displacementFromCenter |
	displacementFromCenter := self center - aPoint.
			displacementFromCenter isZero
				ifFalse: [
			self acceleratedBy: aNumber * displacementFromCenter normal]! !

!BallMorph methodsFor: 'physics' stamp: 'hjo 4/21/2009 10:56'!
applyFriction

	self velocity: self velocity * 0.98! !

!BallMorph methodsFor: 'halos and balloon help' stamp: 'hjo 7/18/2009 16:51'!
balloonHelpDelayTime

	^1! !

!BallMorph methodsFor: 'list sel highlight' stamp: 'hjo 7/18/2009 16:30'!
beNotUnselected
	self unselected: false.
	self
		color: (self color alpha: 1.0)! !

!BallMorph methodsFor: 'list sel highlight' stamp: 'hjo 7/18/2009 16:30'!
beUnselected
	self unselected: true.
	self
		color: (self color alpha: 0.2)! !

!BallMorph methodsFor: 'accessing' stamp: 'hjo 5/24/2009 13:43'!
charge

	^charge setDefault: #defaultCharge for: self withSetter: #charge:! !

!BallMorph methodsFor: 'accessing' stamp: 'hjo 5/24/2009 13:43'!
charge: anObject
		
	charge := anObject! !

!BallMorph methodsFor: 'testing' stamp: 'hjo 5/21/2009 16:35'!
contentsIs: aByteString 

	^false! !

!BallMorph methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2009 17:10'!
contentsOrBalloonText

	^self balloonText! !

!BallMorph methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2009 17:24'!
createCloneIn: anIdeaMap 

	| newBall |
	self revisit: 'BUG: position of merged balls are very strange: in-line '.
	newBall := self class newPosition: anIdeaMap positionToCreateNewBall.
	newBall setBalloonText: self balloonText maxLineLength: self balloonText size.
	anIdeaMap addElectricForceConnectedBall: newBall! !

!BallMorph methodsFor: 'defaults' stamp: 'hjo 5/24/2009 13:43'!
defaultCharge

	"Return a default object for instance variable charge."
	^1! !

!BallMorph methodsFor: 'defaults' stamp: 'hjo 4/21/2009 11:07'!
defaultMass

	"Return a default object for instance variable mass."
	^500! !

!BallMorph methodsFor: 'defaults' stamp: 'hjo 4/21/2009 10:54'!
defaultVelocity

	"Return a default object for instance variable velocity."
	^0@0! !

!BallMorph methodsFor: 'contents labeling' stamp: 'hjo 8/5/2009 17:07'!
deleteLabel

	"do nothing"
	^self! !

!BallMorph methodsFor: 'physics' stamp: 'hjo 4/28/2009 00:09'!
forcedBy: aPoint 

	self acceleratedBy: aPoint / self mass! !

!BallMorph methodsFor: 'physics' stamp: 'hjo 7/18/2009 14:31'!
forcedByElectricSealMorph: anElectricSealMorph 
	| roomBounds myCenter dl dr dt db gap |
	gap := 50.
	roomBounds := anElectricSealMorph bounds.
	myCenter := self untruncatedCenter.
	"Clamp inside the bounds"
	roomBounds left + gap < myCenter x
		ifFalse: [self position: self position - self velocity.
			self velocity: self velocity x negated @ self velocity y].
	myCenter x + gap < roomBounds right
		ifFalse: [self position: self position - self velocity.
			self velocity: self velocity x negated @ self velocity y].
	roomBounds top + gap < myCenter y
		ifFalse: [self position: self position - self velocity.
			self velocity: self velocity x @ self velocity y negated].
	myCenter y + gap < roomBounds bottom
		ifFalse: [self position: self position - self velocity.
			self velocity: self velocity x @ self velocity y negated].
	"forced by wall charge"
	dl := myCenter x - roomBounds left.
	dr := roomBounds right - myCenter x.
	dt := myCenter y - roomBounds top.
	db := roomBounds bottom - myCenter y.
	self forcedBy: 10000 * self charge * anElectricSealMorph charge * (1 @ 0 / dl + (-1 @ 0 / dr) + (0 @ 1 / dt) + (0 @ -1 / db))! !

!BallMorph methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2009 17:14'!
getFromIdeaMap: anIdeaMap 

	^anIdeaMap getBallNamed: self balloonText! !

!BallMorph methodsFor: 'initialization' stamp: 'hjo 4/28/2009 11:46'!
initialize

	super initialize.
	self borderWidth: 0.
	self extent: 40@40! !

!BallMorph methodsFor: 'as yet unclassified' stamp: 'hjo 9/16/2009 17:34'!
isIncludedIn: anIdeaMap 

	^anIdeaMap balls anySatisfy: [:each | each balloonText = self balloonText ]! !

!BallMorph methodsFor: 'accessing' stamp: 'hjo 4/28/2009 00:08'!
mass

	^mass setDefault: #defaultMass for: self withSetter: #mass:! !

!BallMorph methodsFor: 'accessing' stamp: 'hjo 4/21/2009 11:06'!
mass: anObject
		
	mass := anObject! !

!BallMorph methodsFor: 'physics' stamp: 'hjo 8/5/2009 14:50'!
moveByVelocity
	self
		bounds: (self bounds translateBy: self velocity)! !

!BallMorph methodsFor: 'contents labeling' stamp: 'hjo 7/31/2009 09:27'!
openLabel
	"do nothing"! !

!BallMorph methodsFor: 'contents labeling' stamp: 'hjo 7/31/2009 09:24'!
setLabelMorphFont
	"do nothing"! !

!BallMorph methodsFor: 'contents labeling' stamp: 'hjo 7/31/2009 09:07'!
setLabelMorphPosition
	"do nothing i dont have a concept"! !

!BallMorph methodsFor: 'stepping and presenter' stamp: 'hjo 8/5/2009 14:50'!
step
	super step.
	self moveByVelocity.
	self applyFriction! !

!BallMorph methodsFor: 'testing' stamp: 'hjo 4/21/2009 10:53'!
stepTime

	^17! !

!BallMorph methodsFor: 'printing' stamp: 'hjo 9/3/2009 17:52'!
storeOn: aWriteStream

	"aWriteStream nextPutAll: self class printString."
	aWriteStream print: self class.
	aWriteStream nextPutAll: ' newPosition: '.
	aWriteStream print: self position.! !

!BallMorph methodsFor: 'accessing' stamp: 'hjo 7/11/2009 12:11'!
unselected: aBoolean 
	unselected := aBoolean! !

!BallMorph methodsFor: 'testing' stamp: 'hjo 7/17/2009 13:04'!
untruncatedCenter
	
	| myBounds |
	myBounds := self bounds.
	^((myBounds left + myBounds right)  / 2)@
	((myBounds top + myBounds bottom)  / 2)
! !

!BallMorph methodsFor: 'accessing' stamp: 'hjo 4/28/2009 00:08'!
velocity

	^velocity setDefault: #defaultVelocity for: self withSetter: #velocity:! !

!BallMorph methodsFor: 'accessing' stamp: 'hjo 4/21/2009 10:54'!
velocity: anObject
		
	velocity := anObject! !

BallMorph subclass: #ConceptBallMorph
	instanceVariableNames: 'contents labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics'!

!ConceptBallMorph classSide methodsFor: 'instance creation' stamp: 'hjo 9/3/2009 15:04'!
newConceptName: aByteString position: aPoint 

	^self new 
		contents: aByteString; 
		position: aPoint; 
		yourself! !

!ConceptBallMorph methodsFor: 'accessing' stamp: 'hjo 5/21/2009 16:18'!
contents

	^contents setDefault: #defaultContents for: self withSetter: #contents:! !

!ConceptBallMorph methodsFor: 'accessing' stamp: 'hjo 7/31/2009 09:36'!
contents: aString 
	contents := aString.
	self setBalloonText: aString.
	self deleteLabel.
	self openLabel! !

!ConceptBallMorph methodsFor: 'testing' stamp: 'hjo 5/21/2009 17:24'!
contentsIs: aByteString

	^self contents = aByteString! !

!ConceptBallMorph methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2009 17:25'!
createCloneIn: anIdeaMap 

	anIdeaMap addElectricForceConnectedBall: (self class newConceptName: self contents position: anIdeaMap positionToCreateNewBall)
	
! !

!ConceptBallMorph methodsFor: 'defaults' stamp: 'hjo 5/21/2009 16:19'!
defaultContents

	"Return a default object for instance variable contents."
	^'name me'! !

!ConceptBallMorph methodsFor: 'defaults' stamp: 'hjo 8/5/2009 17:09'!
defaultLabelMorph
	^self contents asMorph.
! !

!ConceptBallMorph methodsFor: 'contents labeling' stamp: 'hjo 8/5/2009 17:07'!
deleteLabel
	labelMorph isNil
		ifFalse: [labelMorph delete.
			self labelMorph: nil]! !

!ConceptBallMorph methodsFor: 'initialization' stamp: 'hjo 5/21/2009 16:23'!
initialize

	super initialize.
	self color: Color green! !

!ConceptBallMorph methodsFor: 'as yet unclassified' stamp: 'hjo 9/16/2009 17:26'!
isIncludedIn: anIdeaMap 

	^anIdeaMap balls anySatisfy: [:each| each contentsIs: self contents] ! !

!ConceptBallMorph methodsFor: 'accessing' stamp: 'hjo 8/5/2009 17:08'!
labelMorph
	^ labelMorph
		setDefault: #defaultLabelMorph
		for: self
		withSetter: #labelMorph:! !

!ConceptBallMorph methodsFor: 'accessing' stamp: 'hjo 8/5/2009 17:08'!
labelMorph: aStringMorph 

	labelMorph := aStringMorph! !

!ConceptBallMorph methodsFor: 'testing' stamp: 'hjo 8/5/2009 17:51'!
labelMorphIsNil
	^labelMorph isNil! !

!ConceptBallMorph methodsFor: 'contents labeling' stamp: 'hjo 7/31/2009 09:29'!
openLabel
	self labelMorph openInWorld.
	self addMorph: self labelMorph.
	self setLabelMorphPosition.
	self setLabelMorphFont! !

!ConceptBallMorph methodsFor: 'contents labeling' stamp: 'hjo 7/31/2009 09:24'!
setLabelMorphFont
	self labelMorph font: (StrikeFontSet familyName: 'Accuny' size: 18)! !

!ConceptBallMorph methodsFor: 'contents labeling' stamp: 'hjo 7/31/2009 09:07'!
setLabelMorphPosition
	self labelMorph position: self right + 5 @ self center y! !

!ConceptBallMorph methodsFor: 'printing' stamp: 'hjo 9/3/2009 18:24'!
storeOn: aWriteStream

	aWriteStream print: self class.
	aWriteStream nextPutAll: ' newConceptName:'.
	aWriteStream print: self contents.
	aWriteStream nextPutAll: ' position: '.
	aWriteStream print: self position.! !

EllipseMorph subclass: #UnmovableBodyMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics'!

!UnmovableBodyMorph methodsFor: 'physics' stamp: 'hjo 3/7/2009 13:12'!
acceleratedBy: aPoint 

	"I shall not move!!!!"! !

!UnmovableBodyMorph methodsFor: 'physics' stamp: 'hjo 3/7/2009 13:13'!
forcedBy: aPoint 

	"I shall not move!!!!"! !

!UnmovableBodyMorph methodsFor: 'initialization' stamp: 'hjo 3/7/2009 15:34'!
initialize

	super initialize.
	self extent: 20@20! !

WAFunctionalTest subclass: #WAIdeaMapConcepAdder
	instanceVariableNames: 'input'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics-Seaside'!

!WAIdeaMapConcepAdder methodsFor: 'initialize-release' stamp: 'hjo 7/22/2009 18:07'!
initialize
	super initialize.
	self input: 'a text'! !

!WAIdeaMapConcepAdder methodsFor: 'accessing' stamp: 'hjo 7/22/2009 18:07'!
input
	^input! !

!WAIdeaMapConcepAdder methodsFor: 'accessing' stamp: 'hjo 7/22/2009 18:14'!
input: aString 
	IdeaMap allInstances anyOne addConceptBalls: aString.
	input := aString! !

!WAIdeaMapConcepAdder methodsFor: 'rendering' stamp: 'hjo 7/22/2009 18:07'!
renderContentOn: html
	html form: [
		html div: [
			self renderInputOn: html.
			self renderSubmitOn: html.
			self renderResetOn: html.
			self renderPushOn: html ] ]! !

!WAIdeaMapConcepAdder methodsFor: 'rendering' stamp: 'hjo 7/22/2009 18:10'!
renderInputOn: html 
	html
		table: [html
				tableRow: [html tableHeading: 'LiveConcepts'.
					html tableData: self input].
			html
				tableRow: [html tableHeading: 'Concept names to add:'.
					html
						tableData: [html textInput on: #input of: self]]]! !

!WAIdeaMapConcepAdder methodsFor: 'rendering' stamp: 'hjo 7/22/2009 18:07'!
renderPushOn: html
	html heading level2 with: 'Push'.
	html paragraph: 'Clicking the button should not do anything.'.
	html button bePush; with: 'Push'! !

!WAIdeaMapConcepAdder methodsFor: 'rendering' stamp: 'hjo 7/22/2009 18:07'!
renderResetOn: html
	html heading level2 with: 'Reset'.
	html paragraph: 'Clicking the button should not submit the form reset the value in "Input"'.
	html button beReset; with: 'Reset'! !

!WAIdeaMapConcepAdder methodsFor: 'rendering' stamp: 'hjo 7/22/2009 18:07'!
renderSubmitOn: html
	html heading level2 with: 'Submit'.
	html paragraph: 'Clicking the button should submit the form and update the value in "Value:" with the value in "Input"'.
	html button with: 'Submit'! !

RectangleMorph subclass: #ElectricSealMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics'!

!ElectricSealMorph methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2009 13:05'!
charge

	^1! !

!ElectricSealMorph methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2009 13:01'!
step
	super step.
	self submorphs
		do: [:each | each forcedByElectricSealMorph: self]! !

!ElectricSealMorph methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2009 13:08'!
stepTime

	^17! !

PolygonMorph subclass: #ForceMorph
	instanceVariableNames: 'ball1 ball2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics'!

ForceMorph subclass: #ElectricForceMorph
	instanceVariableNames: 'force'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics'!

!ElectricForceMorph methodsFor: 'physics' stamp: 'hjo 4/26/2009 18:09'!
applyForceBothEnds: aPoint

	super applyForceBothEnds: aPoint.
	self force: aPoint! !

!ElectricForceMorph methodsFor: 'defaults' stamp: 'hjo 4/26/2009 18:08'!
defaultForce

	^ 0@0! !

!ElectricForceMorph methodsFor: 'accessing' stamp: 'hjo 4/26/2009 18:08'!
force

	^force setDefault: #defaultForce for: self withSetter: #force:! !

!ElectricForceMorph methodsFor: 'accessing' stamp: 'hjo 4/26/2009 18:08'!
force: anObject
		
	force := anObject! !

!ElectricForceMorph methodsFor: 'physics' stamp: 'hjo 9/17/2009 17:32'!
forceFromDisplacementVector: aPoint

	^aPoint isZero
		ifTrue: [  (1000000 atRandom @ 1000000 atRandom) * self ball1 charge * self ball2 charge ]
		ifFalse: [aPoint / (aPoint r raisedTo: 3) * 1000000 * self ball1 charge * self ball2 charge]! !

!ElectricForceMorph methodsFor: 'initialization' stamp: 'hjo 4/21/2009 14:35'!
initialize

	super initialize.
	self makeOpen.
	self borderColor: Color blue lighter.! !

!ElectricForceMorph methodsFor: 'physics' stamp: 'hjo 8/29/2009 08:38'!
lineWidthForForce

	^self force r! !

!ElectricForceMorph methodsFor: 'physics' stamp: 'hjo 8/29/2009 08:39'!
updateAppearance

	self borderWidth: self lineWidthForForce! !

!ForceMorph classSide methodsFor: 'instance creation' stamp: 'hjo 4/21/2009 21:13'!
newConnecting: aBallMorph and: aBallMorph2 

	^self new
		ball1: aBallMorph;
		ball2: aBallMorph2! !

!ForceMorph methodsFor: 'physics' stamp: 'hjo 4/21/2009 21:33'!
applyForce

	self applyForceBothEnds: (self forceFromDisplacementVector: self ballDisplacementVector)! !

!ForceMorph methodsFor: 'physics' stamp: 'hjo 4/21/2009 21:00'!
applyForceBothEnds: aPoint 

	ball1 forcedBy: aPoint.
	ball2 forcedBy: aPoint negated! !

!ForceMorph methodsFor: 'physics' stamp: 'hjo 4/21/2009 21:00'!
attachTo: aBallMorph and: aBallMorph2 

	self setVertices: (Array with: aBallMorph center with: aBallMorph2 center).
! !

!ForceMorph methodsFor: 'physics' stamp: 'hjo 8/6/2009 14:20'!
attachToCenterOfTwoBalls
	self attachTo: self ball1 and: self ball2.! !

!ForceMorph methodsFor: 'accessing' stamp: 'hjo 4/27/2009 23:58'!
ball1

	^ball1 setDefault: #defaultBall1 for: self withSetter: #ball1:! !

!ForceMorph methodsFor: 'accessing' stamp: 'hjo 4/21/2009 21:00'!
ball1: aBallMorph 

	ball1 _ aBallMorph! !

!ForceMorph methodsFor: 'accessing' stamp: 'hjo 4/27/2009 23:58'!
ball2

	^ball2 setDefault: #defaultBall2 for: self withSetter: #ball2:! !

!ForceMorph methodsFor: 'accessing' stamp: 'hjo 4/21/2009 21:00'!
ball2: aBallMorph 

	ball2 _ aBallMorph! !

!ForceMorph methodsFor: 'physics' stamp: 'hjo 4/21/2009 21:00'!
ballDisplacementVector

	^ball1 center - ball2 center! !

!ForceMorph methodsFor: 'accessing' stamp: 'hjo 7/11/2009 13:30'!
balls
	^Array with: self ball1 with: self ball2! !

!ForceMorph methodsFor: 'testing' stamp: 'hjo 9/9/2009 21:54'!
connecting: aBallMorph1 and: aBallMorph2
	
	^(Set with: ball1 with: ball2) = (Set with: aBallMorph1 with: aBallMorph2)! !

!ForceMorph methodsFor: 'physics' stamp: 'hjo 4/21/2009 21:19'!
currentLength

	^self ballDisplacementVector r! !

!ForceMorph methodsFor: 'defaults' stamp: 'hjo 4/27/2009 23:59'!
defaultBall1

	^UnmovableBodyMorph new openInWorld
		center: self vertices first! !

!ForceMorph methodsFor: 'defaults' stamp: 'hjo 4/28/2009 00:00'!
defaultBall2

	^UnmovableBodyMorph new openInWorld
		center: self vertices first! !

!ForceMorph methodsFor: 'initialization' stamp: 'hjo 5/24/2009 10:34'!
initialize

	super initialize.
	self beSticky! !

!ForceMorph methodsFor: 'stepping and presenter' stamp: 'hjo 8/6/2009 14:20'!
step
	super step.
	self attachToCenterOfTwoBalls.
	self applyForce.
	self updateAppearance! !

!ForceMorph methodsFor: 'testing' stamp: 'hjo 4/21/2009 21:00'!
stepTime

	^17! !

!ForceMorph methodsFor: 'physics' stamp: 'hjo 4/26/2009 18:02'!
updateAppearance

	"do something to change the appearance of me.
	#step calls me."! !

ForceMorph subclass: #RubberBandMorph
	instanceVariableNames: 'stableLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics'!

!RubberBandMorph classSide methodsFor: 'eToys-scripting' stamp: 'hjo 4/28/2009 10:57'!
additionsToViewerCategories
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories."

	^
	#(
		(rubberBand 
			(
				(slot stableLength 'Length that I get easy with.' Number readWrite Player getStableLength Player setStableLength: )
			)
		)
	)


! !

!RubberBandMorph methodsFor: 'defaults' stamp: 'hjo 4/21/2009 11:21'!
defaultStableLength

	"Return a default object for instance variable stableLength."
	^200! !

!RubberBandMorph methodsFor: 'physics' stamp: 'hjo 4/27/2009 23:32'!
forceFromDisplacementVector: aPoint

	| dist |
	dist _ aPoint r.
	^dist isZero
		ifTrue: [ Point r: 1 degrees: 360 atRandom ]
		ifFalse: [ aPoint / dist * (self stableLength - dist) ]! !

!RubberBandMorph methodsFor: 'initialization' stamp: 'hjo 4/21/2009 11:15'!
initialize

	super initialize.
	self makeOpen.
	self borderColor: Color black.! !

!RubberBandMorph methodsFor: 'physics' stamp: 'hjo 8/28/2009 19:45'!
lineWidthForLength: aNumber

	^(self stableLength / aNumber)*3 max: 1! !

!RubberBandMorph methodsFor: 'accessing' stamp: 'hjo 7/4/2009 19:54'!
stableLength
	^stableLength
		setDefault: #defaultStableLength
		for: self
		withSetter: #stableLength:! !

!RubberBandMorph methodsFor: 'accessing' stamp: 'hjo 4/21/2009 11:21'!
stableLength: anObject
		
	stableLength := anObject! !

!RubberBandMorph methodsFor: 'physics' stamp: 'hjo 8/29/2009 08:23'!
updateAppearance

	| length |
	length := self currentLength.
	length isZero
		ifTrue: [ "do nothing" ]
		ifFalse: [ self borderWidth: (self lineWidthForLength: length) ]! !

JoystickMorph subclass: #JoystickMorphForIdeaMapCenterRotation
	instanceVariableNames: 'target actionSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics-Tools'!

!JoystickMorphForIdeaMapCenterRotation methodsFor: 'accessing' stamp: 'hjo 6/24/2009 14:24'!
actionSelector

	^actionSelector setDefault: #defaultActionSelector for: self withSetter: #actionSelector:! !

!JoystickMorphForIdeaMapCenterRotation methodsFor: 'accessing' stamp: 'hjo 6/24/2009 14:24'!
actionSelector: anObject
		
	actionSelector := anObject! !

!JoystickMorphForIdeaMapCenterRotation methodsFor: 'defaults' stamp: 'hjo 6/24/2009 14:24'!
defaultActionSelector

	^#yourself
	! !

!JoystickMorphForIdeaMapCenterRotation methodsFor: 'as yet unclassified' stamp: 'hjo 6/24/2009 14:25'!
mouseMove: evt
	"Make handle track the cursor within my bounds."

	super mouseMove: evt.
	target ifNotNil: [ target angularlyAcceleratedBy:self leftRight/2 ].! !

!JoystickMorphForIdeaMapCenterRotation methodsFor: 'as yet unclassified' stamp: 'hjo 7/31/2009 17:09'!
target: anObject

	target := anObject! !

JoystickMorph subclass: #PluggableJoystickMorph
	instanceVariableNames: 'target actionSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics-Tools'!

!PluggableJoystickMorph methodsFor: 'accessing' stamp: 'hjo 6/23/2009 17:14'!
actionSelector

	^actionSelector setDefault: #defaultActionSelector for: self withSetter: #actionSelector:! !

!PluggableJoystickMorph methodsFor: 'accessing' stamp: 'hjo 6/23/2009 17:14'!
actionSelector: anObject
		
	actionSelector := anObject! !

!PluggableJoystickMorph methodsFor: 'defaults' stamp: 'hjo 6/23/2009 17:15'!
defaultActionSelector

	^#yourself
	! !

!PluggableJoystickMorph methodsFor: 'as yet unclassified' stamp: 'hjo 6/24/2009 17:20'!
mouseMove: evt
	"Make handle track the cursor within my bounds."

	super mouseMove: evt.
	target ifNotNil: [ target perform: actionSelector with: (self leftRight @ self upDown negated)/4 ].! !

!PluggableJoystickMorph methodsFor: 'accessing' stamp: 'hjo 7/31/2009 17:06'!
target: anObject 

	super target: anObject.
	target := anObject! !

Object subclass: #IdeaMap
	instanceVariableNames: 'balls electricForceMorphs rubberBandMorphs conceptsSelected conceptsSelectedCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics-Application'!

!IdeaMap classSide methodsFor: 'examples' stamp: 'hjo 5/7/2009 18:27'!
example

"e _IdeaMap new .
e deleteMorphs.
e addNewBall.
e addNewBallRubberBandConnectedToAll: e balls.
e addNewBallRubberBandConnectedToAll: {e balls at: 3}
e electricForceMorphs do: [:each| each hide ]
ElectricForceMorph allInstances do: [:each| each hide]"! !

!IdeaMap classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2009 17:47'!
wipeOutAllMorphs

	self allInstances do: [:each| each deleteMorphs ].
	BallMorph allSubInstances do: [:each| each delete].
	ForceMorph allSubInstances do: [:each| each delete].! !

!IdeaMap classSide methodsFor: 'examples' stamp: 'hjo 9/14/2009 17:53'!
workspaceSaved

| e |
e _self new.
e balls do: [:each| each openLabel ].
e balls do: [:each| each setLabelMorphPosition. each setLabelMorphFont. ]
e deleteMorphs.
e conceptsSelectedCollection
e addConceptBalls: 'John, Mary, Baby' centerNamed: 'fusion'.
e addConceptBalls: 'MIT, Casey Reas ,Benjamin Fry ,Design by Numbers'.
e addConceptBalls: 'Processing, Casey Reas,  Benjamin Fry'.
e addConceptBalls: 'Processing, ElectronicArts, Visual Design Community'.
e addConceptBalls: 'Processing, Design by Numbers'.
e addConceptBalls: 'Processing, Mobile Processing, Francis Li'.

(e balls reject: [:each| each isKindOf: ConceptBallMorph ]) do: [:each| each extent: 10@10. each mass: 200].

e zoom: 0.5.
e setAllStableLength: 100.

(e getConceptBallNamed: 'Processing') mass: 2000.
e balls do:[:each| each mass:100].! !

!IdeaMap methodsFor: 'physics' stamp: 'hjo 5/24/2009 13:39'!
acceleratedBy: aPoint 

	self balls do: [:each| each acceleratedBy: aPoint ]! !

!IdeaMap methodsFor: 'as yet unclassified' stamp: 'hjo 9/16/2009 17:23'!
addBallIfMissing: aBallMorph 

	(aBallMorph isIncludedIn: self)
		ifFalse: [ aBallMorph createCloneIn: self  ]
	! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 7/11/2009 10:42'!
addConceptBallFromUser
	self  addConceptBalls: (FillInTheBlank request: 'Enter concepts separated by comman(,)')! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 7/11/2009 10:49'!
addConceptBalls: aByteString 
	"very powerful method"
	^self addConceptBalls: aByteString centerNamed: aByteString! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 9/7/2009 13:47'!
addConceptBalls: aByteString centerNamed: aByteString2 
	"very powerful method"
	| words ballsToConnect |
	words := aByteString subStrings: ','.
	ballsToConnect := words
				collect: [:nameString | self getOrCreateConceptBallNamed: nameString trimBlanks].
	ballsToConnect isEmpty
		ifTrue: [^self].
	
	self connectExistingConcepts: ballsToConnect centerNamed: aByteString2.
! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 9/16/2009 17:14'!
addElectricForceConnectedBall: aBallMorph

	self addElectricForceConnectedToBallMorph: aBallMorph.
	self balls add: aBallMorph.
	^aBallMorph! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 9/10/2009 13:13'!
addElectricForceConnectedToBallMorph: aBallMorph

	^Array streamContents: [ :added |
		self balls do: [:each| | e | e := ElectricForceMorph newConnecting: each and: aBallMorph. self electricForceMorphs add: e. e hide. added nextPut: e ].
	]! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 5/26/2009 00:57'!
addNewBall

	^self addNewBallOfClass: BallMorph! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 9/10/2009 13:18'!
addNewBallOfClass: aClass

	| b |
	b := aClass new.
	b position: 100 atRandom @ 100 atRandom + 100.
	b openInWorld.
	(self addElectricForceConnectedToBallMorph: b)
		do: [:each| each openInWorld. each hide ].
	self balls add: b.
	^b! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 9/10/2009 13:21'!
addNewBallRubberBandConnectedToAll: anArray

	| b |
	(self balls includesAllOf: anArray) ifFalse: [ self error: 'Morphs to connect rubber must be included in balls.' ].
	b := self addNewBall.
	anArray do: [:each| self notVerifiedAddRubberBandConnecting: b and: each ].
	^b
	! !

!IdeaMap methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2009 17:14'!
addRubberBandMorphIfMissing: aRubberBandMorph 

	| ball1 ball2 |
	ball1 := aRubberBandMorph ball1 getFromIdeaMap: self.
	ball2 := aRubberBandMorph ball2 getFromIdeaMap: self.
	(self hasRubberbandMorphConnecting: ball1 and: ball2)
		ifFalse: [ self notVerifiedAddRubberBandConnecting: ball1 and: ball2 ]! !

!IdeaMap methodsFor: 'physics' stamp: 'hjo 8/28/2009 12:44'!
angularlyAcceleratedBy: aNumber 
	| c |
	self balls isEmpty ifTrue: [ ^self ].
	c := self centerOfMass.
	self balls
		do: [:each | 
			each angularlyAcceleratedBy: aNumber rotationCenterPoint: c.
			"displacementFromCenterOfMass := each center - c.
			displacementFromCenterOfMass isZero
				ifFalse: [each acceleratedBy: aNumber * displacementFromCenterOfMass normal]"]! !

!IdeaMap methodsFor: 'accessing' stamp: 'hjo 5/4/2009 00:47'!
balls

	^balls setDefault: #defaultBalls for: self withSetter: #balls:! !

!IdeaMap methodsFor: 'accessing' stamp: 'hjo 5/4/2009 00:47'!
balls: anObject
		
	balls := anObject! !

!IdeaMap methodsFor: 'as yet unclassified' stamp: 'hjo 9/16/2009 17:32'!
canComputeCenterOfMass

	^self balls isEmpty not! !

!IdeaMap methodsFor: 'testing' stamp: 'hjo 7/31/2009 12:21'!
canConnectSelectedConceptsStar
	^ self conceptsSelectedCollection isEmpty not! !

!IdeaMap methodsFor: 'physics' stamp: 'hjo 5/24/2009 14:10'!
centerOfMass

	^(self balls collect: [:each| each center * each mass ]) sum / (self balls collect: [:each| each mass]) sum! !

!IdeaMap methodsFor: 'accessing' stamp: 'hjo 7/9/2009 19:57'!
conceptNameList
	^ self balls asArray collect: [:each| each balloonText]! !

!IdeaMap methodsFor: 'accessing' stamp: 'hjo 7/10/2009 13:56'!
conceptsSelected
	^ 0! !

!IdeaMap methodsFor: 'accessing' stamp: 'hjo 7/9/2009 20:10'!
conceptsSelected: aSmallInteger 
	conceptsSelected := aSmallInteger.
	! !

!IdeaMap methodsFor: 'list sel many' stamp: 'hjo 7/9/2009 20:27'!
conceptsSelectedAt: anInteger 
		| conceptBall |
	conceptBall := self balls at: anInteger.

	^self conceptsSelectedCollection includes: conceptBall! !

!IdeaMap methodsFor: 'list sel many' stamp: 'hjo 9/14/2009 18:27'!
conceptsSelectedAt: aSmallInteger put: aBoolean 
	| conceptBall messageName |
	conceptBall := self balls at: aSmallInteger.
	messageName := aBoolean
				ifTrue: [#copyWith:]
				ifFalse: [#copyWithout:].
	self
		conceptsSelectedCollection: (self conceptsSelectedCollection perform: messageName with: conceptBall).
	(aBoolean
			and: [self conceptsSelectedCollection size = 1])
		ifTrue: [self balls
				do: [:each | each beUnselected]].
	aBoolean
		ifTrue: [conceptBall beNotUnselected]
		ifFalse: [conceptBall beUnselected].
	self conceptsSelectedCollection isEmpty
		ifTrue: [self balls
				do: [:each | each beNotUnselected]].
	self updateIDE! !

!IdeaMap methodsFor: 'accessing' stamp: 'hjo 7/9/2009 20:25'!
conceptsSelectedCollection

	^conceptsSelectedCollection setDefault: #defaultConceptsSelectedCollection for: self withSetter: #conceptsSelectedCollection:! !

!IdeaMap methodsFor: 'accessing' stamp: 'hjo 7/9/2009 20:25'!
conceptsSelectedCollection: anObject
		
	conceptsSelectedCollection := anObject! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 7/31/2009 12:35'!
connectExistingConcepts: anCollection centerNamed: aByteString 
	| centerBall |
	centerBall := self addNewBallOfClass: BallMorph.
	centerBall setBalloonText: aByteString.
	anCollection
		do: [:conceptBall | self notVerifiedAddRubberBandConnecting: centerBall and: conceptBall].
	self changed: #conceptNameList.! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 7/31/2009 11:16'!
connectSelectedConceptsStar

	| centerNameFromUser |
	centerNameFromUser := (FillInTheBlank request: 'Center name?').
	centerNameFromUser isEmpty ifFalse: [
	self
		connectExistingConcepts: self conceptsSelectedCollection
		centerNamed: centerNameFromUser]! !

!IdeaMap methodsFor: 'ide-joysticks' stamp: 'hjo 7/31/2009 19:51'!
createAccelearationJoystick
	| joystick |
	joystick := PluggableJoystickMorph new.
	joystick actionSelector: #acceleratedBy:.
	joystick target: self.
	^joystick! !

!IdeaMap methodsFor: 'ide-joysticks' stamp: 'hjo 8/4/2009 16:17'!
createAccelearationJoystickWithText

	^AlignmentMorph
				inARow: (Array
						with: self createAccelearationJoystick
						with: (TextMorph boldAuthoringPrototype contents: 'panning')).
	! !

!IdeaMap methodsFor: 'ide-button rows' stamp: 'hjo 7/31/2009 23:30'!
createBottomButtonsRow
	| aRow |
	aRow := AlignmentMorph
				inARow: (Array with: self createStarButton with: self createCutConnectionButton).
	aRow color: Color veryVeryLightGray.
	aRow cellInset: 4;
		 layoutInset: 6.
	^ aRow! !

!IdeaMap methodsFor: 'ide-buttons' stamp: 'hjo 7/31/2009 19:56'!
createBringToCenterOfDisplayButton
	| button |
	button := SimpleButtonMorph new.
	button beCuteStyle.
	button label: 'bring to center of display'.
	button actionSelector: #moveCenterOfMassToDisplayCenter.
	button target: self.
	^button! !

!IdeaMap methodsFor: 'ide' stamp: 'hjo 7/31/2009 19:54'!
createConceptListMorph
	| listMorph |
	listMorph := PluggableListMorphOfMany new.
	listMorph
		on: self
		list: #conceptNameList
		primarySelection: #conceptsSelected
		changePrimarySelection: #conceptsSelected:
		listSelection: #conceptsSelectedAt:
		changeListSelection: #conceptsSelectedAt:put:
		menu: nil
		keystroke: nil.
	listMorph color: Color lightBlue.
	listMorph autoDeselect: true.
	listMorph extent: 150 @ 250.
	listMorph updateList.
^listMorph! !

!IdeaMap methodsFor: 'ide-buttons' stamp: 'hjo 7/31/2009 20:05'!
createCutConnectionButton
	| button |
	button := SimpleButtonMorph new.
	button beCuteStyle.
	button label: 'cut connections'.
	button actionSelector: #deleteRubberBandsBetweenSelectedConcepts.
	button target: self.
	^button! !

!IdeaMap methodsFor: 'ide-buttons' stamp: 'hjo 8/4/2009 16:30'!
createDeleteMorphsButton
	| button |
	button := SimpleButtonMorph new.
	button beCuteStyle.
	button label: 'delete morphs'.
	button actionSelector: #deleteMorphs.
	button target: self.
	^ button! !

!IdeaMap methodsFor: 'as yet unclassified' stamp: 'hjo 9/15/2009 08:46'!
createFileButtonsRow

	| buttons aRow  |
	buttons := Array with: self createFileSaveButton with: self createFileOpenButton with: self createFileMergeButton.
	aRow := AlignmentMorph inARow: buttons.
	aRow color: Color veryVeryLightGray.
	aRow cellInset: 4.
	aRow layoutInset: 6.
	^ aRow! !

!IdeaMap methodsFor: 'as yet unclassified' stamp: 'hjo 9/15/2009 08:47'!
createFileMergeButton

	| button |
	button := SimpleButtonMorph new.
	button beCuteStyle.
	button label: ' merge... '.
	button actionSelector: #mergeFromFile.
	button target: self.
	^button! !

!IdeaMap methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2009 18:04'!
createFileOpenButton

	| button |
	button := SimpleButtonMorph new.
	button beCuteStyle.
	button label: ' load... '.
	button actionSelector: #loadFromFile.
	button target: self.
	^button! !

!IdeaMap methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2009 18:00'!
createFileSaveButton

	| button |
	button := SimpleButtonMorph new.
	button beCuteStyle.
	button label: ' save... '.
	button actionSelector: #saveOnFile.
	button target: self.
	^button! !

!IdeaMap methodsFor: 'ide' stamp: 'hjo 9/14/2009 17:56'!
createIDE
	| morph |
	morph := AlignmentMorph
				inAColumn: (Array
						with: self createJoystickBundle
						with: self createTopButtonsRow
						with: self createSecondTopButtonsRow
						with: self createConceptListMorph
						with: self createBottomButtonsRow
						with: self createFileButtonsRow).
	morph color: Color veryVeryLightGray.
	^ morph! !

!IdeaMap methodsFor: 'ide-joysticks' stamp: 'hjo 8/4/2009 16:20'!
createJoystickBundle
	| aColumn |
	aColumn := AlignmentMorph
				inAColumn: (Array with: self createAccelearationJoystickWithText with: self createRotationJoystickWithText).
	aColumn setNameTo: 'Column'.
	aColumn color: Color veryVeryLightGray.
	aColumn cellInset: 4;
		 layoutInset: 6.
	^ aColumn! !

!IdeaMap methodsFor: 'ide-buttons' stamp: 'hjo 7/31/2009 19:56'!
createPlusButton
	| button |
	button := SimpleButtonMorph new.
	button beCuteStyle.
	button label: ' + '.
	button actionSelector: #addConceptBallFromUser.
	button target: self.
	^button! !

!IdeaMap methodsFor: 'ide-joysticks' stamp: 'hjo 7/31/2009 19:51'!
createRotationJoystick
	| joystick |
	joystick := JoystickMorphForIdeaMapCenterRotation new.
	joystick target: self.
	^joystick! !

!IdeaMap methodsFor: 'ide-joysticks' stamp: 'hjo 8/4/2009 16:19'!
createRotationJoystickWithText

	^AlignmentMorph
				inARow: (Array
						with: self createRotationJoystick
						with: (TextMorph boldAuthoringPrototype contents: 'rotating')).! !

!IdeaMap methodsFor: 'ide-button rows' stamp: 'hjo 8/4/2009 16:30'!
createSecondTopButtonsRow
	| aRow |
	aRow := AlignmentMorph
				inARow: (Array with: self createDeleteMorphsButton).
	aRow color: Color veryVeryLightGray.
	aRow cellInset: 4;
		 layoutInset: 6.
	^ aRow! !

!IdeaMap methodsFor: 'ide-buttons' stamp: 'hjo 7/31/2009 20:04'!
createStarButton
	| starButton |
	starButton := PluggableButtonMorphPlus
				on: self
				getState: nil
				action: #connectSelectedConceptsStar.
	starButton label: 'star'.
	starButton beCuteStyle.
	starButton getEnabledSelector: #canConnectSelectedConceptsStar.
	^ starButton! !

!IdeaMap methodsFor: 'ide-button rows' stamp: 'hjo 7/31/2009 19:59'!
createTopButtonsRow
	| aRow |
	aRow := AlignmentMorph
				inARow: (Array with: self createPlusButton with: self createBringToCenterOfDisplayButton).
	aRow color: Color veryVeryLightGray.
	aRow cellInset: 4;
		 layoutInset: 6.
		^aRow! !

!IdeaMap methodsFor: 'defaults' stamp: 'hjo 5/4/2009 00:47'!
defaultBalls

	^OrderedCollection new! !

!IdeaMap methodsFor: 'defaults' stamp: 'hjo 7/9/2009 20:05'!
defaultConceptsSelected
	^nil! !

!IdeaMap methodsFor: 'defaults' stamp: 'hjo 7/9/2009 20:26'!
defaultConceptsSelectedCollection
	^OrderedCollection new! !

!IdeaMap methodsFor: 'defaults' stamp: 'hjo 5/4/2009 00:51'!
defaultElectricForceMorphs

	^OrderedCollection new! !

!IdeaMap methodsFor: 'defaults' stamp: 'hjo 5/4/2009 00:51'!
defaultRubberBandMorphs

	^OrderedCollection new! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 7/31/2009 12:35'!
deleteMorphs
	self balls
		do: [:each | each delete].
	self balls: nil.
	self electricForceMorphs
		do: [:each | each delete].
	self electricForceMorphs: nil.
	self rubberBandMorphs
		do: [:each | each delete].
	self rubberBandMorphs: nil.
	conceptsSelectedCollection := nil.
	conceptsSelected := 0.
	self changed: #conceptNameList! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 8/29/2009 20:09'!
deleteRubberBandsBetweenSelectedConcepts

	| rubberBandToDelete |
	rubberBandToDelete := RubberBandMorph allInstances select: [: each| self conceptsSelectedCollection includesAllOf: each balls ].
	rubberBandToDelete do: [:each| each delete ].
	self rubberBandMorphs: (self rubberBandMorphs copyWithoutAll: rubberBandToDelete)! !

!IdeaMap methodsFor: 'accessing' stamp: 'hjo 5/4/2009 00:51'!
electricForceMorphs

	^electricForceMorphs setDefault: #defaultElectricForceMorphs for: self withSetter: #electricForceMorphs:! !

!IdeaMap methodsFor: 'accessing' stamp: 'hjo 5/4/2009 00:51'!
electricForceMorphs: anObject
		
	electricForceMorphs := anObject! !

!IdeaMap methodsFor: 'physics' stamp: 'hjo 5/24/2009 13:38'!
forcedBy: aPoint 

	self balls do: [:each| each forcedBy: aPoint ]! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 8/29/2009 20:05'!
getBallNamed: aByteString 

	^self balls detect: [:each| each balloonText  = aByteString ]! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 5/21/2009 16:35'!
getConceptBallNamed: aByteString 

	^self balls detect: [:each| each contentsIs: aByteString ] ifNone: []! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 5/21/2009 17:22'!
getOrCreateConceptBallNamed: aByteString 

	^self balls detect: [:each| each contentsIs: aByteString] ifNone: [ (self addNewBallOfClass: ConceptBallMorph) contents: aByteString ]! !

!IdeaMap methodsFor: 'testing' stamp: 'hjo 9/9/2009 21:32'!
hasRubberBandConnecting:  ballmorph1 and: ballmorph2

	^self rubberBandMorphs anySatisfy: [:each| each connecting: ballmorph1 and: ballmorph2 ]! !

!IdeaMap methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2009 17:16'!
hasRubberbandMorphConnecting: morph1 and: morph2

	^self rubberBandMorphs anySatisfy: [:each| (Set with: each ball1 with: each ball2) = (Set with: morph1 with: morph2) ]! !

!IdeaMap methodsFor: 'testing' stamp: 'hjo 7/31/2009 12:20'!
isOn
	"for PluggableButtonMorph"
	^ true! !

!IdeaMap methodsFor: 'file' stamp: 'hjo 9/14/2009 19:05'!
loadFromFile

	| fib objectFromFile |
	fib := FillInTheBlank request: 'file name?'.
	fib isEmpty ifFalse: [
		self deleteMorphs.
		objectFromFile := (FileStream readOnlyFileNamed: fib) fileInObjectAndCode.
		self copyFrom: objectFromFile.
		self openMorphs.
		self orderMorphs.
		self updateIDE
	]! !

!IdeaMap methodsFor: 'as yet unclassified' stamp: 'hjo 9/16/2009 17:19'!
mergeFrom: anIdeaMap 

	anIdeaMap balls do: [:each| self addBallIfMissing: each ].
	anIdeaMap rubberBandMorphs do: [:each| self addRubberBandMorphIfMissing: each ]! !

!IdeaMap methodsFor: 'file' stamp: 'hjo 9/17/2009 17:38'!
mergeFromFile

	| fib objectFromFile |
	fib := FillInTheBlank request: 'file name?'.
	fib isEmpty ifFalse: [
		self deleteMorphs.
		objectFromFile := (FileStream readOnlyFileNamed: fib) fileInObjectAndCode.
		self mergeFrom: objectFromFile.
		self openMorphs.
		self orderMorphs.
		self updateIDE.
		self electricForceMorphs do: [:each| each hide ].
		self moveCenterOfMassToDisplayCenter.
	]! !

!IdeaMap methodsFor: 'physics' stamp: 'hjo 5/31/2009 08:58'!
moveCenterOfMassToDisplayCenter

	| jump |
	jump := Display center - self centerOfMass.
	self balls do: [:each| each center: each center + jump ]! !

!IdeaMap methodsFor: 'operations' stamp: 'hjo 5/21/2009 17:28'!
notVerifiedAddRubberBandConnecting: ball1 and: ball2

	| r |
	r := RubberBandMorph newConnecting: ball1 and: ball2. 
	r stableLength: 100.
	r openInWorld. 
	self rubberBandMorphs add: r. 
	r goBehind.
	^r	! !

!IdeaMap methodsFor: 'ide' stamp: 'hjo 7/31/2009 20:03'!
openIDE
	self createIDE openInHand! !

!IdeaMap methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2009 18:23'!
openMorphs

	self balls do: [:each| each openInWorld].
	self rubberBandMorphs do: [:each| each openInWorld].
	self electricForceMorphs do: [:each| each openInWorld].! !

!IdeaMap methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2009 18:58'!
orderMorphs

	self electricForceMorphs, self rubberBandMorphs , self balls
		do: [:each| each comeToFront]! !

!IdeaMap methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2009 17:37'!
positionToCreateNewBall

	self revisit: 'make sure every ball is created using this.'.
	^(self canComputeCenterOfMass 
		ifTrue: [ self centerOfMass ]
		ifFalse: [ Display center ]) + (100 atRandom @ 100 atRandom)! !

!IdeaMap methodsFor: 'accessing' stamp: 'hjo 5/4/2009 00:51'!
rubberBandMorphs

	^rubberBandMorphs setDefault: #defaultRubberBandMorphs for: self withSetter: #rubberBandMorphs:! !

!IdeaMap methodsFor: 'accessing' stamp: 'hjo 5/4/2009 00:51'!
rubberBandMorphs: anObject
		
	rubberBandMorphs := anObject! !

!IdeaMap methodsFor: 'controlling' stamp: 'hjo 5/24/2009 14:08'!
setAllStableLength: aNumber

	self rubberBandMorphs do: [:each| each stableLength: aNumber ]! !

!IdeaMap methodsFor: 'as yet unclassified' stamp: 'hjo 9/16/2009 17:12'!
setLabelMorphPosition

	self balls do: [:each| each setLabelMorphPosition ]! !

!IdeaMap methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2009 18:26'!
updateIDE

	self changed: #conceptNameList.
	self changed: #canConnectSelectedConceptsStar.! !

!IdeaMap methodsFor: 'controlling' stamp: 'hjo 5/24/2009 13:51'!
zoom: aFloat

	"| chargeFactor |
	chargeFactor := aFloat sqrt reciprocal."
	self rubberBandMorphs do: [:each| each stableLength: each stableLength * aFloat ].
	"self balls do: [:each| each charge: each charge * chargeFactor ]"! !

Object subclass: #RubberMesh
	instanceVariableNames: 'b1 b2 b3 b4 c s1 s2 s3 s4 i1 i2 i3 i4'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphoPhysics-Application'!

!RubberMesh methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2009 00:29'!
deleteMorphs

	{b1. b2. b3. b4. c. s1. s2. s3. s4. i1. i2. i3. i4} do: [:morph| morph delete ].! !

!RubberMesh methodsFor: 'as yet unclassified' stamp: 'hjo 4/28/2009 00:41'!
openMorphs

	| sideLength centerLength |
	sideLength := 2 * 100.
	centerLength := 2 sqrt * 100.
	b1 := BallMorph new openInWorld.
	b2 := BallMorph new openInWorld.
	b3 := BallMorph new openInWorld.
	b4 := BallMorph new openInWorld.
	c := BallMorph new openInWorld.

	s1 := RubberBandMorph newConnecting: b1 and: b2.
	s1 stableLength: sideLength.
	s1 openInWorld.

	s2 := RubberBandMorph newConnecting: b2 and: b3.
	s2 stableLength: sideLength.
	s2 openInWorld.

	s3 := RubberBandMorph newConnecting: b3 and: b4.
	s3 stableLength: sideLength.
	s3 openInWorld.

	s4 := RubberBandMorph newConnecting: b4 and: b1.
	s4 stableLength: sideLength.
	s4 openInWorld.

	i1 := RubberBandMorph newConnecting: b1 and: c.
	i1 stableLength: centerLength.
	i1 openInWorld.

	i2 := RubberBandMorph newConnecting: b2 and: c.
	i2 stableLength: centerLength.
	i2 openInWorld.

	i3 := RubberBandMorph newConnecting: b3 and: c.
	i3 stableLength: centerLength.
	i3 openInWorld.

	i4 := RubberBandMorph newConnecting: b4 and: c.
	i4 stableLength: centerLength.
	i4 openInWorld.

	b1 position: 200@200.
	b2 position: 300@200.
	b3 position: 300@300.
	b4 position: 200@300.
	{b1. b2. b3. b4. c} do: [:each| each comeToFront ].
	c position: (b1 position + b2 position + b3 position + b4 position) / 4.

! !

!Player methodsFor: '*MorphoPhysics' stamp: 'hjo 4/4/2009 18:02'!
accelerateXBy: aNumber

	costume acceleratedBy: aNumber@0! !

!Player methodsFor: '*MorphoPhysics' stamp: 'hjo 4/4/2009 18:03'!
accelerateYBy: aNumber

	costume acceleratedBy: 0@aNumber! !

!Player methodsFor: '*MorphoPhysics' stamp: 'hjo 3/12/2009 17:14'!
getMass

	^costume mass! !

!Player methodsFor: '*MorphoPhysics' stamp: 'hjo 4/28/2009 10:58'!
getStableLength

	^costume stableLength! !

!Player methodsFor: '*MorphoPhysics' stamp: 'hjo 4/4/2009 09:59'!
getVelocityX

	^costume velocity x! !

!Player methodsFor: '*MorphoPhysics' stamp: 'hjo 4/4/2009 10:03'!
getVelocityY

	^costume velocity y! !

!Player methodsFor: '*MorphoPhysics' stamp: 'hjo 3/12/2009 17:14'!
setMass: aNumber

	costume mass: aNumber! !

!Player methodsFor: '*MorphoPhysics' stamp: 'hjo 4/28/2009 10:58'!
setStableLength: aNumber

	costume stableLength: aNumber! !

!Player methodsFor: '*MorphoPhysics' stamp: 'hjo 4/4/2009 10:00'!
setVelocityX: aNumber

	^costume velocity: (aNumber @ costume velocity y)! !

!Player methodsFor: '*MorphoPhysics' stamp: 'hjo 4/4/2009 10:03'!
setVelocityY: aNumber

	^costume velocity: (costume velocity x @ aNumber)! !
